/*
2015Jan9
 Explore using current PC time as licensing feature. Explore using hashing as license file
 this is almost to the limit and getting more difficult to add more features as the design document is not there
 after some times, most probably diffcult to understd
 About 7*8hr to complete. Amazing that I can come so far...
*/

import processing.pdf.*; //for pdf printing

int gridX=50, gridY=50, width=1400, height=800;
float percentDraw=0.8; //how much of height is for legion
float startLegion=percentDraw*height;

float freqMin=10, freqMax=1000e6, freqStep=10;
float dbMin=-100, dbMax=100, dbStep=10, dbRef=0;
float degMin=-270, degMax=180, degStep=22.5, degRef=-180;
int   NoLineFreq=int(log10(freqMax/freqMin));
int   NoLineDB=int((dbMax-dbMin)/dbStep);   //no of line need for grid
int   NoLineDEG=int((degMax-degMin)/degStep);
int   gridDB=int(startLegion/NoLineDB); //size per grid
int   gridDEG=int(startLegion/NoLineDEG);
int   gridFreq=width/NoLineFreq;

float FT_asympotic, PM_asympotic, FT, PM; //store the current FT, PM

int   keyState; //keypress state, try tie with msgState. keypress type: 0 normal, 1 add pole,
int   keyStateSub; //state for 2nd level of cmd
int   msgState; //type of message to display
int   keyStateStack, msgStateStack; //stack to store previous states, when cmd require entry of data

String entryTyping="", entrySaved="VDD1234"; 
int entryMax=12;//for entry box
int   previousKey; //stack

int   modeRecalc=1; //0 no chg in graph, 1 must re-calc & updategraph
int   modeDyn=0; //dymamic mode, to drag PZ or display PM info in real time
//when click highlighted node, modeDyn=1, keyState=11, if m end, if d, modeDyn=2, keyState=12, if d, draw result
int   modePlot=0; //0 for db, 1 for deg, 2 for both
int   modeLine=2; //0 for approx all, 1 for actual all, 2 for all, 3 for asymp tot, 4 for actual tot
int   modeInfo=0; //toggle display of PZ and scale
int   previousPlot=0, previousLine=2; //for 'c' mode which combine db+deg plot
float[] ptTemp1       =new float[2];
float[] ptTemp2       =new float[2];
float[] ptFreqDbDeg =new float[3]; //{freq,dB,deg}

float resnGrid=min(width/gridX, height/gridY);
//coordinate ref pt for legion area
float legX1=1*resnGrid; //1st half
float legX2=29*resnGrid; //2nd half
float legX3=51*resnGrid; //3rd half
float legY=startLegion+2.0*resnGrid;

//dynamic mode related
int Dp;  int DpMax=31;//inclusive 
float Dang=0;
float[] DArrayF=new float[DpMax];  
float[] DArrayDB=new float[DpMax];
float[] DArrayX=new float[DpMax];  
float[] DArrayY=new float[DpMax];
float[] DArrayFT=new float[DpMax]; 
float[] DArrayPM=new float[DpMax]; 


boolean recordPDF=false;
PrintWriter bodeFile;
int fileNo=0; //everytime a file is png or pdf, this no increase
String bodeFileName="bodePara.txt";
String[] bodeLine;
String  bodeName="temp";


int PZ_t=-1; 
float PZ_g=0, PZ_q=0, PZ_f1=1000, PZ_f2=1000; //hold PZ val for 'a' add PZ

color green=#098E0E, blue=#1925A2, red=#D30D3B, nwell=#F26F1D;
color black=#7C6F72, via1=#0A0A0A, pdiff=#D125E5, ndiff=#25DDE5;
color gray=#7C6F72, white=#EDEBEB, lightgray=#D8D8C7;
color currentLayer;

remarksBox    rB;              //remark box, contains text message
legionBox     lB;              //legion box
drawBox       dB;              //drawing box
sysPara       sB;              //system Para
PZ            p1, p2;
PZlist        plist;

class sysPara {
  float[] freqBase = {    1, 2, 3, 4, 5, 6, 7, 8, 9}; //only 9 pt per dec
  float[] freqBaseFine= {1  };  //more resolution
  float     resnArray = 100; //1000 will slow down programme
  int     sizeArray = NoLineFreq*freqBase.length*int(resnArray)+1; //this equation is pre-calculated
  float[] freqArray = new float[sizeArray]; //to hold array for ref line
  float[] dbArray =   new float[sizeArray];
  float[] degArray =  new float[sizeArray];
  String sInfo=""; //info of scale in String for saving to file
  String sInfo_screen="";

  sysPara() { //base freq array don't change, forever is fixed
    float[] freqBaseT = {      1, 2, 3, 4, 5, 6, 7, 8, 9, 10}; //only 9 pt per dec
    //prepare an freqBaseFine [1,1.1....9.8,9.9] for better resn of freq Array
    for (int i = 1; i <freqBaseT.length; i = i+1) {
      for (int j = 1; j <= int(resnArray); j++) {
        float y = lerp(freqBaseT[i-1], freqBaseT[i], j/resnArray);
        if (y!=10) {        freqBaseFine=append(freqBaseFine, y);    }
      }
    }
  }
  void genFreqArray() {

    float start=freqMin;
    NoLineFreq=int(log10(freqMax/freqMin));
    sizeArray = NoLineFreq*freqBase.length*int(resnArray)+1; //this equation is pre-calculated
    NoLineDB=int((dbMax-dbMin)/dbStep);   //no of line need for grid
    NoLineDEG=int((degMax-degMin)/degStep);
    gridDB=int(startLegion/NoLineDB); //size per grid
    gridDEG=int(startLegion/NoLineDEG);
    gridFreq=width/NoLineFreq;
    //prepare the reference line for dB & deg
    float[] tfreqArray = new float[sizeArray]; //resize the Array
    float[] tdbArray =   new float[sizeArray];
    float[] tdegArray =  new float[sizeArray];

    for (int i = 0; i < NoLineFreq; i = i+1) {
      for (int j = 0; j < freqBaseFine.length; j++) {
        //println(i,j,sizeArray,NoLineFreq,freqBaseFine.length);
        tfreqArray[i*freqBaseFine.length+j]=freqBaseFine[j]*start;
        tdbArray[i*freqBaseFine.length+j]=dbRef;
        tdegArray[i*freqBaseFine.length+j]=degRef;
      }
      start=start*10;
    }
    //************this last pt give error???
    //tfreqArray[freqArray.length-1]=start; //last point
    //tdbArray[freqArray.length-1]=dbRef; 
    //tdegArray[freqArray.length-1]=degRef; 
    freqArray=tfreqArray;     dbArray=tdbArray;    degArray=tdegArray;
  }
  //draw grid and label
  void update() { //need to call genFreqArray() be4 update
    String s;     float step;
    //draw either db or deg line & scale
    textSize(1*resnGrid); 
    strokeWeight(1);
    if (modePlot==0 || modePlot==2) {
      for (int i = 0; i < NoLineDB; i++ ) {
        fill(black);   stroke(black);
        line(0, i*gridDB, width, i*gridDB);
        step=dbMax-i*dbStep; 
        if (floor(step)==step) {    s=str(int(floor(step)));}
        else {s=String.format("%.2f", step);} 
        if (i==1) {s=s+"dB";} //2st item add unit
        text(s, 0, i*gridDB);
      }
      bodeName="bode_db";
    }
    if (modePlot==1 || modePlot==2) {
      for (int i = 0; i < NoLineDEG; i++ ) {
        fill(green);    stroke(green);
        if (modePlot==1) {line(0, i*gridDEG, width, i*gridDEG); } //don't plot axis of deg for combined plot, confuse
        step=degMax-i*degStep; 
        if (floor(step)==step) {  s=str(int(floor(step)));}
        else { s=String.format("%.2f", step);} 
        if (i==1) {s=s+"deg";} //2st item add unit
        text(s, width-5*resnGrid, i*gridDEG);
      }
      bodeName="bode_deg";
    }
    //draw the freq semilog grid & scale
    if (modePlot==0 || modePlot==2) {stroke(black);} else { stroke(green);}
    for (int i = 0; i < NoLineFreq; i++ ) {
      int tx=i*gridFreq;strokeWeight(1); line(tx, 0, tx, startLegion);
      step=freqMin*pow(freqStep, i); 
      if (floor(step)==step) {  s=str(int(floor(step)));}
      else {s=String.format("%.2f", step);} 
      s=formatFreq(float(s), 0)+"Hz";
      if (i!=0) {  
        if (modePlot==0 || modePlot==2) {text(s, tx, gridDB);} 
        else {text(s, tx, gridDEG);}
      }
      else {} //1st item not display
      strokeWeight(0.5);
      for (int j=0; j<10; j++) {
        float txx=tx+log10(j)*gridFreq;
        line(txx, 0, txx, startLegion);
      }
    }
    //draw the ref line for db and deg
    if (modePlot==0 || modePlot==2) {drawPlot(freqArray, dbArray, 0, black, 2, 0);}
    if (modePlot==1 || modePlot==2) {drawPlot(freqArray, degArray, 1, green, 2, 0);}
    //don't convert to int(freq***) as 0.1 become 0...
    sInfo="freqMin:"+str(freqMin)+", freqMax:"+str(freqMax)+", freqStep:"+str(freqStep)+"\n"+
      "dbMin:"+str(dbMin)+", dbMax:"+str(dbMax)+", dbStep:"+str(dbStep)+"\n"+
      "degMin:"+str(degMin)+", degMax:"+str(degMax)+", degStep:"+str(degStep)+"\n";
    sInfo_screen="freqMin:"+formatFreq(freqMin, 0)+"Hz, freqMax:"+formatFreq(freqMax, 0)+"Hz.\n"+
      "dbMin:"+str(dbMin)+", dbMax:"+str(dbMax)+", dbStep:"+str(dbStep)+"\n"+
      "degMin:"+str(degMin)+", degMax:"+str(degMax)+", degStep:"+str(degStep)+"\n";
  }
} 

class remarksBox {
  String s0="Welcome to seeteck plot...";
  String s1; //define in update() 
  String s2; //define in update()
  String s3; //define in update()
  String s4="toggling between line type";
  String s5="0 for simple P, 1 simple Z, 2 Q pole, 3 simpe PZ, q to quit";
  String s6="enter index of pole/zero to be removed, q to quit";
  String s7="parameters save to "+bodeFileName;
  String s8="parameters read from "+bodeFileName;
  String s9="freq: 0 min, 1 max, dB: 2 min, 3 max, 4 step, deg: 5 min, 6 max, 7 step";
  String s91="UP key to increase, DOWN decrease, other to quit";
  String s10="dB and deg Plot combined. c to return";
  String s11="m to move PZ, d to enter dynamic mode...";
  String s12="PC could be slow, 'l' line type, 't' orient text, 'o' or 'p' to print";

  String s51="enter gain in dB & hit ENTER";
  String s52="enter freq in Hz & hit ENTER";
  String s53="enter 2nd freq in Hz & hit ENTER";
  String s20="enter data, BACKSPACE to restart, complete with ENTER";
  String s201="ENTER to confirm. Other to abort...";
  String s301="error, no PZ added...";
  String s302="invalid key";
  String s303="max no of Pole/Zero is 5";
  String sBox;
  String sPt, sUnit;


  remarksBox() {
  }
  void update() {
    s2="Save to file  "+bodeName+"_"+str(fileNo)+".pdf";
    s3="Save to file  "+bodeName+"_"+str(fileNo)+".png";
    float[] temp=new float[2];
    //display current mouse coordinate
    fill(green); textSize(1.5*resnGrid); 
    temp=getPt();
    if (modePlot==0) {sUnit="dB";  s1="in db...";}  
    else {sUnit="deg"; s1="in deg...";}
    if (modePlot==0 || modePlot==1) {sPt="Mouse: "+formatFreq(temp[0], 2)+"Hz, "+nfc(temp[1], 2)+sUnit+".";}
    else {sPt="Mouse: "+formatFreq(temp[0], 2)+"Hz, "+nfc(temp[1], 2)+"dB, "+nfc(temp[2], 2)+"deg. ";}
    //display current message
    text(sPt, legX1, legY ); textSize(1.3*resnGrid); 
    switch(msgState) {
    case 0:        sBox=s0;break;     case 1:        sBox=s1;break; 
    case 2:  sBox=s2;break;    case 3:sBox=s3; break;     case 4: sBox=s4; break; 
    case 5: sBox=s5; break;case 51: sBox=s51; break; case 52:  sBox=s52; break; 
    case 53:  sBox=s53;   break;case 6: sBox=s6; break; case 7:  sBox=s7; break; 
    case 8:  sBox=s8; break;case 9: sBox=s9; break; case 91:  sBox=s91; break; 
    case 10: sBox=s10; break; case 11: sBox=s11; break;
    case 12: sBox=s12; break;case 20:  sBox=s20; break;
    case 201:  sBox=s201; break;case 301:  sBox=s301; break; 
    case 302:  sBox=s302; break; case 303:  sBox=s303; break;
    default:
    }
    text(sBox, legX1, legY+4.5*resnGrid); //the current msg
    //display PM & FT, reuse sBox

    //display info of PM, PZ, or grid info
    if (modeInfo==0) {
      fill(red);textSize(1.5*resnGrid); 
      String s1="", s2="";
      s2="Actual:\n"+"FT: "+formatFreq(FT, 2)+"Hz   PM: "+str(PM)+"deg";
      s1="Asympotic:\n"+"FT: "+formatFreq(FT_asympotic, 2)+"Hz   PM: "+str(PM_asympotic)+"deg";            
      if (modeLine==0) {text(s1, legX3, legY+0*resnGrid); }
      else if (modeLine==1) {  text(s2, legX3, legY+0*resnGrid); }
      else {text(s1+"\n"+s2, legX3, legY+0*resnGrid);}
    }
    else if (modeInfo==1) {fill(black);textSize(1*resnGrid);text(plist.sInfo_screen, legX3, legY);}
    else {fill(black);textSize(1*resnGrid);text(sB.sInfo_screen, legX3, legY);}
    textSize(1.5*resnGrid);
    //box for enter of character
    if (keyState==20) {text(entryTyping, legX2+8*resnGrid, legY+0*resnGrid);}
    else if (keyState==1) {
      //labelAlign(currentLAlign);
      //tempPt=returnPt();
      //text(entrySaved,tempPt[0],tempPt[1]);
    }
    else {  }//text(entrySaved,62.5*resnG,8.5*resnG); }
  }
} 

class legionBox { //this display don't change, only draw once will do
  float w=2*resnGrid;
  legionBox() {  }
  void update() {
    fill(lightgray); strokeWeight(1);
    rect(0, startLegion, width, height);
    fill(green);  textSize(0.8*resnGrid);
    text("'d': db/deg, 'p': pdf, 'o': png, 's': save data, 'r': read data, 'l': line type, 'a': add PZ, "+
      "\n'n': delete PZ, 'i': info, 'u':axis rescale, 'c': db+deg   ", 
    1*resnGrid, startLegion+8*resnGrid);
    stroke(black);strokeWeight(1);    noFill();     
    rect(legX2+8.0*resnGrid, legY-2.0*resnGrid, 6*w, 1.5*w);   
    fill(black); textSize(1.5*resnGrid); 
    text("data entry:", legX2, legY);
  }
} 

class drawBox { //only need to draw once in setup()
  drawBox() {  }
  void update() { strokeWeight(1);    fill(white);  rect(0, 0, width, height); }
} 


class PZ {
  int type; //type, 0=pole, 1=complex pole, 2=zero
  float gDb, Q, f1, f2;
  float f1_gDb,f2_gDb, f2_gDeg, f1_gDeg; //each f1,f2 has correspond _gDb and _gDeg for dot
  float f1a, f2a, f1a_gDeg, f2a_gDeg; //for simple P&Z, need another info for dot when P&Z separated <100X
  boolean highlight_f1=false; boolean highlight_f2=false;    
  float[] F_DB, F_DEG, DB, DEG;  //few pt plot of freq resp
  float[] fArray, dbArray, degArray;        //actual value of freq resp
  float[]         dbArrayA, degArrayA;      //ideal value of freq resp
  String sInfo;  //info of this PZ, for para read/write
  String sInfo_screen; //for display
  PZ(int t, float q, float g, float ff1, float ff2) { //type,gain,Q,f1,f2
    type=t;     gDb=g;     Q=q;    f1=ff1;     f2=ff2;
    if (type>=0 && type<=2){f2=0;f2_gDb=0;}
  }
  void calcCurve(float[] f) { 
    //this is called by PZList()
    //calc individual PZ asympotic_few_pt, asympotic and actual response

    //provide a few pt to represent asympotic plot
    if (type==0) {//simple pole
      F_DB= new float[3];    DB= new float[3];
      F_DB[0]=freqMin;  F_DB[1]=f1;    F_DB[2]=freqMax;DB[0]=gDb;   DB[1]=gDb;   DB[2]=20*log10(1/(freqMax/f1))+gDb;
      F_DEG= new float[4]; DEG= new float[4];F_DEG[0]=freqMin;F_DEG[1]=f1/10; F_DEG[2]=10*f1;  F_DEG[3]=freqMax;
      DEG[0]=0;   DEG[1]=0;   DEG[2]=-90;    DEG[3]=-90;
      sInfo=       "type:0, simple pole, Q:"+str(Q)+", gain:"+str(gDb)+"dB, f1:"+str(f1)+"Hz";
      sInfo_screen="type:0, simple pole, Q:"+str(Q)+", gain:"+str(gDb)+"dB, f1:"+formatFreq(f1, 2)+"Hz";
      f1_gDb=gDb; f1_gDeg=-45;
    }  
    else if (type==1) {//simple zero
      F_DB= new float[3];  DB= new float[3];  F_DB[0]=freqMin;  F_DB[1]=f1;   F_DB[2]=freqMax;
      DB[0]=gDb;        DB[1]=gDb;     DB[2]=-20*log10(1/(freqMax/f1))+gDb;F_DEG= new float[4]; DEG= new float[4];
      F_DEG[0]=freqMin; F_DEG[1]=f1/10; F_DEG[2]=10*f1;  F_DEG[3]=freqMax;
      DEG[0]=0;         DEG[1]=0;       DEG[2]=90;       DEG[3]=90;      
      sInfo="type:1, simple zero, Q:"+str(Q)+", gain:"+str(gDb)+"dB, f1:"+str(f1)+"Hz";
      sInfo_screen="type:1, simple zero, Q:"+str(Q)+", gain:"+str(gDb)+"dB, f1:"+formatFreq(f1, 2)+"Hz";
      f1_gDb=gDb; f1_gDeg=45;
    }    
    else if (type==2) {//Quad P, you need only Q and f1 (fo), 2 pole are fo/Q & Q*fo
      F_DB= new float[3];   DB= new float[3];
      F_DB[0]=freqMin; F_DB[1]=f1;    F_DB[2]=freqMax;
      DB[0]=gDb;         DB[1]=gDb;      DB[2]=40*log10(1/(freqMax/f1))+gDb;
      F_DEG= new float[4]; DEG= new float[4];
      F_DEG[0]=freqMin;  F_DEG[1]=f1/10;  F_DEG[2]=10*f1;   F_DEG[3]=freqMax;
      DEG[0]=0;           DEG[1]=0;       DEG[2]=-180;      DEG[3]=-180;
      sInfo=       "type:2, quadratic pole, Q:"+str(Q)+", gain:"+str(gDb)+"dB, f1:"+str(f1)+"Hz";
      sInfo_screen="type:2, quadratic pole, Q:"+str(Q)+", gain:"+str(gDb)+"dB, f1:"+formatFreq(f1, 2)+"Hz";
      f1_gDb=gDb;f1_gDeg=-45;
    }    
    else if (type==3) {//Simple P+Z, f1 is P, f2 is Z. it can be P>Z or Z>P
      F_DB= new float[4];    DB= new float[4];
      if (f2>=f1) { //P smaller
            F_DB[0]=freqMin;  F_DB[1]=f1;     F_DB[2]=f2;  F_DB[3]=freqMax;
            DB[0]=gDb;        DB[1]=gDb;    DB[2]=20*log10(1/(F_DB[2]/f1))+gDb;   DB[3]=DB[2]; 
            f1_gDb=gDb;f2_gDb=DB[2];
            if (f2<100*f1) { //pt is [2] and [4]
              F_DEG= new float[7]; DEG= new float[7]; F_DEG[0]=freqMin; 
              F_DEG[1]=f1/10;  F_DEG[3]=sqrt(f1*f2); F_DEG[5]=10*f2;   F_DEG[6]=freqMax;F_DEG[2]=sqrt(F_DEG[1]*F_DEG[3]); 
              F_DEG[4]=sqrt(F_DEG[3]*F_DEG[5]);
              DEG[0]=0;          DEG[1]=0;     DEG[2]=-45*log10(F_DEG[2]/F_DEG[1]);
              DEG[3]=-45*log10(F_DEG[3]/F_DEG[1]);   
              DEG[4]=DEG[3]+45*log10(F_DEG[4]/(F_DEG[3])); 
              DEG[5]=DEG[3]+45*log10(F_DEG[5]/(F_DEG[3]));   DEG[6]=0;
              f1a=F_DEG[2]; f2a=F_DEG[4]; f1a_gDeg=DEG[2];  f2a_gDeg=DEG[4];
            }
            else { //pt is [2] and [5]
              F_DEG= new float[8];     DEG= new float[8];
              F_DEG[0]=freqMin; F_DEG[1]=f1/10;  F_DEG[2]=f1;  F_DEG[3]=10*f1; F_DEG[4]=f2/10; F_DEG[5]=f2;      F_DEG[6]=10*f2;  F_DEG[7]=freqMax;
              DEG[0]=0;         DEG[1]=0;       DEG[2]=-45;  DEG[3]=-90;   DEG[4]=-90;       DEG[5]=-45;     DEG[6]=0;    DEG[7]=0;
              f1_gDeg=DEG[2];f2_gDeg=DEG[5];
            }
      }
      else {//zero smaller than pole
            F_DB[0]=freqMin;  F_DB[1]=f2;     F_DB[2]=f1;  F_DB[3]=freqMax;
            DB[0]=gDb;        DB[1]=gDb;    DB[2]=-20*log10(1/(F_DB[2]/f2))+gDb;   DB[3]=DB[2]; 
            f2_gDb=gDb;f1_gDb=DB[2];

            if (f1<100*f2) { //pt is [2] and [4]
              F_DEG= new float[7]; DEG= new float[7]; F_DEG[0]=freqMin; 
              F_DEG[1]=f2/10;  F_DEG[3]=sqrt(f1*f2); F_DEG[5]=10*f1;   F_DEG[6]=freqMax;F_DEG[2]=sqrt(F_DEG[1]*F_DEG[3]); 
              F_DEG[4]=sqrt(F_DEG[3]*F_DEG[5]);
              DEG[0]=0;          DEG[1]=0;     DEG[2]=45*log10(F_DEG[2]/F_DEG[1]);
              DEG[3]=45*log10(F_DEG[3]/F_DEG[1]);   
              DEG[4]=DEG[3]-45*log10(F_DEG[4]/(F_DEG[3])); 
              DEG[5]=DEG[3]-45*log10(F_DEG[5]/(F_DEG[3]));   DEG[6]=0;
              f1a=F_DEG[2]; f2a=F_DEG[4]; f1a_gDeg=DEG[2];  f2a_gDeg=DEG[4];
            }
            else { //pt is [2] and [5]
              F_DEG= new float[8];     DEG= new float[8];
              F_DEG[0]=freqMin; F_DEG[1]=f2/10;  F_DEG[2]=f2;  F_DEG[3]=10*f2; F_DEG[4]=f1/10; F_DEG[5]=f1;      F_DEG[6]=10*f1;  F_DEG[7]=freqMax;
              DEG[0]=0;         DEG[1]=0;       DEG[2]=45;  DEG[3]=90;   DEG[4]=90;       DEG[5]=45;     DEG[6]=0;    DEG[7]=0;
              f1_gDeg=DEG[2];f2_gDeg=DEG[5];
            }
      }
      sInfo=       "type:3, simple P&Z, Q:"+str(Q)+", gain:"+str(gDb)+"dB, f1:"+str(f1)+"Hz, f2:"+str(f2)+"Hz";
      sInfo_screen="type:3, simple P&Z, Q:"+str(Q)+", gain:"+str(gDb)+"dB, P:"+formatFreq(f1, 2)+"Hz, Z:"+formatFreq(f2, 2)+"Hz";
    }    

    float db, deg;
    Complex pole1, pole2 ;   
    Complex s1, s2;
    fArray=f;
    int s=fArray.length;
    dbArray =new float[s];  
    degArray =new float[s];  
    dbArrayA =new float[s]; 
    degArrayA =new float[s];
    //individual actual resp
    if (type==0) {//simple pole
      for (int i = 0; i < fArray.length; i = i+1) {
        pole1=new Complex(1, fArray[i]/f1);
        dbArray[i]=gDb-20*log10(pole1.abs);        degArray[i]=-pole1.ang;
        if (fArray[i]<=f1) {          dbArrayA[i]=gDb;        }
        else {     dbArrayA[i]=gDb-20*log10(fArray[i]/f1);     }
        if (fArray[i]<f1/10) {        degArrayA[i]=0;       }
        else if  (fArray[i]>=(f1/10) && fArray[i]<=(f1*10)) {     degArrayA[i]=-45*log10(10*fArray[i]/f1);   }
        else {       degArrayA[i]=-90;    }
      }
    } 
    else if (type==1) {//simple zero
      for (int i = 0; i < fArray.length; i = i+1) {
        pole1=new Complex(1, fArray[i]/f1);
        dbArray[i]=gDb+20*log10(pole1.abs);   degArray[i]=pole1.ang;
        if (degArray[i]<-90) {      degArray[i]=degArray[i]+360;} //single pole or zero is within 90 to -90, rollover issue
        if (fArray[i]<=f1) {dbArrayA[i]=gDb; }
        else {        dbArrayA[i]=gDb+20*log10(fArray[i]/f1);}
        if (fArray[i]<f1/10) {degArrayA[i]=0;}
        else if  (fArray[i]>=(f1/10) && fArray[i]<=(f1*10)) { degArrayA[i]=45*log10(10*fArray[i]/f1); }
        else {degArrayA[i]=90; }
      }
    } 
    else if (type==2) {//quadratic zero
      float ff1, ff2;
      for (int i = 0; i < fArray.length; i = i+1) {//calc actual
        //calc actual
        pole1=returnQP(Q, f1, fArray[i]);
        dbArray[i]=gDb+20*log10(pole1.abs);degArray[i]=+pole1.ang;
        if (degArray[i]>0) {degArray[i]=degArray[i]-360;} //Quadratic Poles from 0 to -180, rollover issue
      }
      //calc asymptotic, must take care of Q
      if (Q>1) {
        ff1=pow(10, -1/(2*Q))*f1; ff2=pow(10, 1/(2*Q))*f1;
        for (int i = 0; i < fArray.length; i = i+1) {
          if (fArray[i]<=f1) {dbArrayA[i]=gDb;}
          else {               dbArrayA[i]=gDb-40*log10(fArray[i]/f1);}
          //degree
          if (fArray[i]<ff1) {degArrayA[i]=0;}
          else if  (fArray[i]>=ff1 && fArray[i]<=ff2) { degArrayA[i]=(-180/log10(ff2/ff1))*log10(fArray[i]/ff1);}
          else {degArrayA[i]=-180;}
        }
      }
      else {
        ff1=Q*f1;ff2=f1/Q;                
        for (int i = 0; i < fArray.length; i = i+1) {
          if       (fArray[i]<=ff1) {dbArrayA[i]=gDb;}
          else if  (fArray[i]>ff1 && fArray[i]<=ff2) {dbArrayA[i]=gDb-20*log10(fArray[i]/ff1); }
          else { dbArrayA[i]=gDb-20*log10(ff2/ff1)-40*log10(fArray[i]/ff2);}
          if (fArray[i]<f1/10) {degArrayA[i]=0;}
          else if  (fArray[i]>=(f1/10) && fArray[i]<=(f1*10)) {degArrayA[i]=-90*log10(10*fArray[i]/f1);}
          else {degArrayA[i]=-180;}
        }
      }
    }
    else if (type==3) {//simple p & z
      for (int i = 0; i < fArray.length; i = i+1) {
        pole1=new Complex(1, fArray[i]/f1); pole2=new Complex(1, fArray[i]/f2);  Complex poleT;
        //actual dB and deg
        if (f2>f1) {poleT=pole1.div(pole2); dbArray[i]=gDb-20*log10(poleT.abs);      degArray[i]=-poleT.ang;   }
        else       {poleT=pole2.div(pole1); dbArray[i]=gDb+20*log10(poleT.abs);      degArray[i]=poleT.ang;   }
        //asympotic dB
        if (f2>f1) { //Z>P
            if (fArray[i]<=f1) {    dbArrayA[i]=gDb;     }
            else if (fArray[i]>f1 && fArray[i]<=f2) {     dbArrayA[i]=gDb-20*log10(fArray[i]/f1); }
            else { dbArrayA[i]=gDb-20*log10(fArray[i]/f1)+20*log10(fArray[i]/f2); }
        }
        else { //P>Z
            if (fArray[i]<=f2) {  dbArrayA[i]=gDb;      }
            else if (fArray[i]>f2 && fArray[i]<=f1) {      dbArrayA[i]=gDb+20*log10(fArray[i]/f2);    }
            else {    dbArrayA[i]=gDb+20*log10(fArray[i]/f2)-20*log10(fArray[i]/f1);    }
        }
        //asympotic deg
        if (f2>f1){//zero>pole
            if (0.1*f2>=0.1*f1 && 0.1*f2<10*f1) {
                if (fArray[i]<f1/10) {    degArrayA[i]=0;     }
                else if  (fArray[i]>=(f1/10) && fArray[i]<(f2/10)) { degArrayA[i]=-45*log10(10*fArray[i]/f1);         }
                else if (fArray[i]>=(f2/10) && fArray[i]<10*f1) {    degArrayA[i]=-45*log10(10*fArray[i]/f1)+45*log10(10*fArray[i]/f2);  }
                else if (fArray[i]>=(10*f1) && fArray[i]<10*f2) {   degArrayA[i]=-90+45*log10(10*fArray[i]/f2);  }
                else {   degArrayA[i]=0;}
            }
            else {
                if (fArray[i]<f1/10) {    degArrayA[i]=0;     }
                else if  (fArray[i]>=(f1/10) && fArray[i]<10*f1) {     degArrayA[i]=-45*log10(10*fArray[i]/f1);  }
                else if (fArray[i]>=10*f1 && fArray[i]<f2/10) {  degArrayA[i]=-90;   }
                else if (fArray[i]>=f2/10 && fArray[i]<10*f2) {   degArrayA[i]=-90+45*log10(10*fArray[i]/f2);    }
                else {       degArrayA[i]=0;    }
            }
        }
        else  {
            if (0.1*f1>=0.1*f2 && 0.1*f1<10*f2) {
                if (fArray[i]<f2/10) {    degArrayA[i]=0;     }
                else if  (fArray[i]>=(f2/10) && fArray[i]<(f1/10)) { degArrayA[i]=45*log10(10*fArray[i]/f2);         }
                else if (fArray[i]>=(f1/10) && fArray[i]<10*f2) {    degArrayA[i]=45*log10(10*fArray[i]/f2)-45*log10(10*fArray[i]/f1);  }
                else if (fArray[i]>=(10*f2) && fArray[i]<10*f1) {   degArrayA[i]=90-45*log10(10*fArray[i]/f1);  }
                else {   degArrayA[i]=0;}
            }
            else {
                if (fArray[i]<f2/10) {    degArrayA[i]=0;     }
                else if  (fArray[i]>=(f2/10) && fArray[i]<10*f2) {     degArrayA[i]=45*log10(10*fArray[i]/f2);  }
                else if (fArray[i]>=10*f2 && fArray[i]<f1/10) {  degArrayA[i]=90;   }
                else if (fArray[i]>=f1/10 && fArray[i]<10*f1) {   degArrayA[i]=90-45*log10(10*fArray[i]/f1);    }
                else {       degArrayA[i]=0;    }
            }
        }
      }
  }
}
void draw() { //drwa individual PZ
  float[] ptTemp=new float[3];
  //check whether mouse is at Point, if so, highlight=true
  ptTemp=getPt();
  //only db or db+deg allow highlight of PZ. Only modeDyn==0 need to highlight, once into dyn mode, cannot highlight
  //highlight_f? is temporary, once mouse is out of dot, no more set
  if ((modePlot==0 || modePlot==2) && modeDyn==0 && ptTemp[0]>=0.9*f1 && ptTemp[0]<=1.1*f1 && ptTemp[1]>=f1_gDb-5 && ptTemp[1]<=f1_gDb+5)
        {highlight_f1=true; }
  else if ((modePlot==0 || modePlot==2) && modeDyn==0 && ptTemp[0]>=0.9*f2 && ptTemp[0]<=1.1*f2 && ptTemp[1]>=f2_gDb-5 && ptTemp[1]<=f2_gDb+5)
        {highlight_f2=true; }
  else {highlight_f1=false;highlight_f2=false;}
  //Plot asympotic plot of each PZ, unnecessary wasteful of resource if plot the Array
  //For trouble shooting, to ensure asympotic result for total resp calc is ok
  //Using few-pt-plot of asympotic, save resource

    //individual db
  int lw=2;
  if (modePlot==0 || modePlot==2) {
    //asympotic
    if (modeLine==0 || modeLine==2 ){drawPlot(F_DB, DB, 0, red, lw, 0);      drawPlot(fArray, dbArrayA, 0, red, lw, 0); }
    //actual
    if (modeLine==1 || modeLine==2 ) {      drawPlot(fArray, dbArray, 0, red, lw, 0);}
  }
  //individual deg
  if (modePlot==1 || modePlot==2) {
    if (modeLine==0 || modeLine==2 ){//drawPlot(F_DEG,  DEG,      1, blue, lw,0);
      drawPlot(fArray, degArrayA, 1, blue, lw, 0); }
    if (modeLine==1 || modeLine==2 ) {
      drawPlot(fArray, degArray, 1, blue, lw, 0);    }
  }

  //put 1 dot at the pole/zero location
  if (type>=0 && type<=2) {//simple pole
    if (modePlot==0 || modePlot==2) {    ptTemp1=freq2draw(f1, f1_gDb, 0);  }
    else if (modePlot==1 ) {       ptTemp1=freq2draw(f1, f1_gDeg, 1);    }
  }
  else if (type==3) {//Simple PZ
    if (modePlot==0 || modePlot==2) {  ptTemp1=freq2draw(f1, f1_gDb, 0);ptTemp2=freq2draw(f2, f2_gDb, 0);}
    else if (modePlot==1) {  
      if (f2>=f1) {if (f2<100*f1) { ptTemp1=freq2draw(f1a, f1a_gDeg, 1); ptTemp2=freq2draw(f2a, f2a_gDeg, 1);  }
                   else {ptTemp1=freq2draw(f1, f1_gDeg, 1); ptTemp2=freq2draw(f2, f2_gDeg, 1);} }
      else {       if (f1<100*f2) { ptTemp1=freq2draw(f1a, f1a_gDeg, 1); ptTemp2=freq2draw(f2a, f2a_gDeg, 1);  }
                   else {ptTemp1=freq2draw(f1, f1_gDeg, 1); ptTemp2=freq2draw(f2, f2_gDeg, 1);} }
    }
  }
  if (modePlot==0 || modePlot==2) {stroke(red);} 
  if (modePlot==1) { stroke(blue);}
  strokeWeight(20);  point(ptTemp1[0], ptTemp1[1]); point(ptTemp2[0], ptTemp2[1]);
  if (highlight_f1==true) {stroke(black);strokeWeight(30);point(ptTemp1[0], ptTemp1[1]);}
  if (highlight_f2==true) {stroke(blue);strokeWeight(30);point(ptTemp2[0], ptTemp2[1]);}
}
}

class PZlist { 
  ArrayList<PZ> PZlist;  
  float[] fArray, dbArray, degArray;        //total actual value of freq resp
  float[]         dbArrayA, degArrayA;      //total ideal value of freq resp
  String sInfo="";  String sInfo_screen="";
  int    selected_index=-1; //-1, not selected. When mouse=PZ, =index, this is only temporary
  Boolean selected_f2=false; //if =true, then f2 is highlighted, else is f1 by default
  Boolean confirmed_f2=false;  //f2 is highlisted, then click, enter dynamic mode
  int    confirmed_index=-1;   //once a PZ is selected, confirmed_index contain the index of PZ
  float  selected_db, selected_f; //contain the f,db to be changed
  float[] anchorStart = new float[2];
  float[] anchorStop  = new float[2];      //{freq,db} pt


  PZlist() {    PZlist = new ArrayList<PZ>();  } 
  void calcCurve(float[] f) {//the freq-axis array
    float db, deg;
    float degRollover=0; //to solve 360deg roll over issues
    Complex poleG, poleF, poleT ;
    fArray=f;
    int tempi=0; 
    float tempF;
    int s=fArray.length;
    dbArray =new float[s];      degArray =new float[s];    dbArrayA =new float[s];     degArrayA =new float[s];
    for (int i = 0; i < s; i = i+1) {
      dbArray[i]=0;      dbArrayA[i]=0;      degArray[i]=0;      degArrayA[i]=0;
    }
    //go through PZ by PZ, add the ideal resp & sInfo
    sInfo="";    sInfo_screen="";
    for (int k = 0; k < PZlist.size(); k = k+1) {
      PZ P = PZlist.get(k);
      P.calcCurve(f);
      for (int i = 0; i < s; i = i+1) {
        dbArrayA[i]=dbArrayA[i]+P.dbArrayA[i];
        degArrayA[i]=degArrayA[i]+P.degArrayA[i];
      }
      sInfo=sInfo+"index:"+str(k)+", "+P.sInfo+"\n";
      sInfo_screen=sInfo_screen+"index:"+str(k)+", "+P.sInfo_screen+"\n";
    }
    //go th freq pt by pt, get all PZ effect, actual freq resp
    for (int i = 0; i < s; i = i+1) { 
      poleT=new Complex(1, 0); //multiply accumulatively at each freq pt
      for (int k = 0; k < PZlist.size(); k = k+1) {
        PZ P = PZlist.get(k);
        if (P.type==0) {
          poleF = new Complex(1, fArray[i]/P.f1);
          poleG = new Complex(pow(10, P.gDb/20), 0);
          poleT = poleT.multi(poleG); //multi by gain
          poleT = poleT.div(poleF);
        }
        else if (P.type==1) {
          poleF = new Complex(1, fArray[i]/P.f1);
          poleG = new Complex(pow(10, P.gDb/20), 0);
          poleT = poleT.multi(poleG); //multi by gain
          poleT = poleT.multi(poleF);
        }
        else if (P.type==2) {
          poleF = returnQP(P.Q, P.f1, fArray[i]);
          poleG = new Complex(pow(10, P.gDb/20), 0);
          poleT = poleT.multi(poleG); //multi by gain
          poleT = poleT.multi(poleF);
        }
        else if (P.type==3) {//simple P+Z
          poleF = new Complex(1, fArray[i]/P.f2);//zero numerator
          poleG = new Complex(1, fArray[i]/P.f1);//pole denominator
          poleF = poleF.div(poleG);
          poleG = new Complex(pow(10, P.gDb/20), 0);//gain
          poleT = poleT.multi(poleG); //multi by gain
          poleT = poleT.multi(poleF);
        }

        dbArray[i]=20*log10(poleT.abs);
        degArray[i]=poleT.ang+degRollover;
        //roll over issues
        if (i>0) { 
          if ((degArray[i]-degArray[i-1])>270) {
            //degRollover=-360;
            degArray[i]=degArray[i]-360;
          } //current pt must be corrected
        }
      }
    }
    //calc FT and PM
    for (int i = 0; i < s; i = i+1)
    {  if (dbArrayA[i]>=0) {        tempi=i;      }      else {        break;      }    } //get index of FT
    FT_asympotic=fArray[tempi];   PM_asympotic=degArrayA[tempi]+180; 
    for (int i = 0; i < s; i = i+1)
    { 
      if (dbArray[i]>=0) {   tempi=i;   }      else {break;}
    } //get index of FT
    FT=fArray[tempi];     PM=degArray[tempi]+180;
  }  

  void draw() {//of PZList
    selected_index=-1; selected_f2=false;//clear and set by later statement;
    PZ P;
    //draw all the individual PZ
    for (int i = 0; i < PZlist.size(); i = i+1) {
      P = PZlist.get(i);   P.draw();
      //decide whether any P or Z is being highlighted, either P.highlight_f1 or P.highlight_f2 is true;
      if (P.highlight_f1==true) { selected_index=i; selected_db=P.f1_gDb;  selected_f=P.f1; selected_f2=false;  }
      else if (P.highlight_f2==true){ selected_index=i; selected_db=P.f2_gDb;  selected_f=P.f2; selected_f2=true;  }  
      else {};      
    }
  }  
  void drawTot(int lw) {
    //draw total resp
    strokeWeight(lw);
    if (modePlot==0 || modePlot==2) {
      if (modeLine==0 || modeLine==2 || modeLine==3) {  drawPlot(fArray, dbArrayA, 0, black, lw, 0); }//asym dB
      if (modeLine==1 || modeLine==2 || modeLine==4) {drawPlot(fArray, dbArray, 0, black, lw, 0);}//actual dB
    }
    if (modePlot==1 || modePlot==2) {
      if (modeLine==0 || modeLine==2 || modeLine==3) {drawPlot(fArray, degArrayA, 1, green, lw, 0);}//asym deg
      if (modeLine==1 || modeLine==2 || modeLine==4) {drawPlot(fArray, degArray, 1, green, lw, 0);}//actual deg
    }
  }
  void drawInfo() {
    //highlight select PZ on inform panel
    PZ P;
    if (modeInfo==1 && selected_index!=-1) {
      P = PZlist.get(selected_index); fill(red);textSize(1*resnGrid);      
      text("index:"+str(selected_index)+", "+P.sInfo_screen+"\n", legX3, legY+selected_index*1.6*resnGrid);
    }
  }
  void add(PZ pz) { PZlist.add(pz); }  
  PZ get(int ind) { return PZlist.get(ind);}  
  void change() {//change the freq,dB of P or Z
    PZ P=PZlist.get(confirmed_index); 
    //println(confirmed_f2, selected_db, selected_f);
    if (P.type>=0 && P.type<=2){ P.gDb=anchorStop[1]; P.f1=anchorStop[0];} //cases where there are only 1 P or 1 Z
    //for simple P & Z
    else { 
        if (confirmed_f2==false){if (P.f2>P.f1) {P.gDb=anchorStop[1]; P.f1=anchorStop[0];}
                                 else           { P.f1=anchorStop[0];}   }
        else {  //Z is selected
             if (P.f2>P.f1){P.f2=anchorStop[0];}                      //only freq of Z is change
             else          {P.f2=anchorStop[0]; P.gDb=anchorStop[1];}} //Z freq & db is chg, since Z<P    
    }
    modeRecalc=1;
  }
  void remove(int i) { PZlist.remove(i);}
  void flush() {    for (int i = this.size()-1; i >=0 ; i--) {      PZlist.remove(i);    }  }
  int size() {     return PZlist.size();  }
}

void setup() {
  float t;
  resetVar();
  size(width, height);  
  sB=new sysPara();
  rB=new remarksBox();
  lB=new legionBox();
  dB=new drawBox();
  plist= new PZlist();
  //t=1/(2*PI*4.7e-6*0.2);   p1=new PZ(0,0,10,t,0);   plist.add(p1);  //Z_esr
  t=9.5e6;                    p1=new PZ(0,0,0,t,0);  plist.add(p1);  //P_sf
  t=25e3;                    p1=new PZ(0,0,60,t,0);    plist.add(p1);//P_ea
  //t=8e3;                    //p1=new PZ(0,0,0,t,0);    plist.add(p1);//P_pmos
  p1=new PZ(3, 0, 0, 6.5e3,174e3);    plist.add(p1); //pmos and zero
  float tpad=1/(2*PI*100e3*10e-12);
  p1=new PZ(0,0,0,tpad,0); plist.add(p1);//pole due to pad
  p1=new PZ(1,0,0,0.5*tpad,0); plist.add(p1);//zero due to pad
  
}

void draw() {
  if (recordPDF==true) {beginRecord(PDF, bodeName+"_"+str(fileNo)+".pdf"); fileNo++; }
  dB.update();
  if (modeRecalc==1) { //calc when the PZ para change to save resource
    sB.genFreqArray(); //create the freq pt
    plist.calcCurve(sB.freqArray);
    modeRecalc=0;
  }

  plist.draw();
  plist.drawTot(5);
  sB.update();
  lB.update();
  rB.update();
  plist.drawInfo(); 
  //react to dymamic mode
  if (modeDyn==1) {
    float[] tStart= new float[2];     float[] tStop = new float[2];
    plist.anchorStop=getPt();
    tStart=freq2draw(plist.selected_f, plist.selected_db, 0);
    tStop =returnPt();
    stroke(nwell);     strokeWeight(2);
    line(tStart[0], tStart[1], tStop[0], tStop[1]);
  }
  //react to dymamic mode
  if (modeDyn==2) {
    PZ tP;
    float prev_f1,prev_f2,prev_gDb; //stack for push/pop
    float tDist;
    float[] tStart= new float[2];float[] tStop = new float[2];
    plist.anchorStop=getPt();
    tStart=freq2draw(plist.selected_f, plist.selected_db, 0);
    tStop =returnPt();
    float[] t = new float[2];
    tP=plist.get(plist.confirmed_index);
    prev_f1=tP.f1;prev_f2=tP.f2;prev_gDb=tP.gDb; //push stack
    fill(red); tDist=dist(tStart[0], tStart[1], tStop[0], tStop[1]);
    //prepare no of pt
    Dp=1+int(floor(tDist/(1.6*resnGrid)));if (Dp>30) {Dp=31;}
    strokeWeight(2);
    for (int i = 0; i < Dp; i++) {//create some pt bet 2 pt and go through
      //create bet pt for start to stop
      DArrayX[i] = lerp(tStart[0], tStop[0], i/float(Dp-1));    DArrayY[i] = lerp(tStart[1], tStop[1], i/float(Dp-1));
      t=draw2freqdeg(DArrayX[i], DArrayY[i]);
      DArrayF[i] = t[0];   DArrayDB[i] = t[1]; //freq,dB array
    
      //chg the para of a P or Z
      if (tP.type>=0 && tP.type<=2) {tP.f1=DArrayF[i];    tP.gDb=DArrayDB[i];}
      else {//if Z of simple P+Z is selected, more complication
          if (plist.confirmed_f2==false){if (tP.f2>tP.f1) {tP.gDb=DArrayDB[i]; tP.f1=DArrayF[i];}
                                   else           { tP.f1=DArrayF[i];}   }
          else {  //Z is selected
               if (tP.f2>tP.f1){tP.f2=DArrayF[i];}                      //only freq of Z is change
               else          {tP.f2=DArrayF[i]; tP.gDb=DArrayDB[i];}} //Z freq & db is chg, since Z<P    
      }

      plist.calcCurve(sB.freqArray);  DArrayFT[i]=FT;   DArrayPM[i]=PM; //store FT&PM
      plist.drawTot(1);  //draw the tot resp
      textSize(1*resnGrid);
      pushMatrix();
      if      (tP.type==3 && plist.confirmed_f2==true &&  tP.f2>tP.f1){translate(DArrayX[i], DArrayY[0]);}//dB cannot chg
      else if (tP.type==3 && plist.confirmed_f2==false && tP.f1>tP.f2){translate(DArrayX[i], DArrayY[0]);}//dB cannot chg
      else                                                            {translate(DArrayX[i], DArrayY[i]);} 

      //translate(DArrayX[i], DArrayY[i]); //cummulative
      rotate(Dang);
      strokeWeight(8);point(0,0);
      text("FT:"+formatFreq(DArrayFT[i], 2)+"Hz, PM:"+DArrayPM[i]+"deg", 0, 0);
      popMatrix();
      modeRecalc=1;
    }
   tP.f1=prev_f1;tP.f2=prev_f2;tP.gDb=prev_gDb; //pop stack 
  }
  if (recordPDF==true) {     recordPDF=false;     endRecord();  }
}



void keyPressed() {
  modeRecalc=1; //lazy, as long keyPress() [no freq], recalc
  //these key always hold regarding any modes
  if (keyState==0) { //base keyState, waiting for 1st level of command
    switch(key) {
    case 'd': 
      if (modePlot<1) {  modePlot++;  } 
      else {   modePlot=0; } //either db or deg, to combine use 'c'
      msgState=1;    break;
    case 'p':    
      recordPDF=true;     msgState=2 ;     break;
    case 'o':
      saveFrame(bodeName+".png");  msgState=3 ;fileNo++;break;
    case 'l': //chg line mode, 1 line or few lines
      if (modeLine<4) { modeLine++;} 
      else {modeLine=0;}msgState=4;  break; 
    case 'a': //add PZ 1st level key;
      keyState=5; msgState=5;  break;
    case 'n': //remove PZ 1st level key;
      keyState=6; msgState=6; break;
    case 'i':
      if (modeInfo<2) {   modeInfo++;  } 
      else {    modeInfo=0;  }  break;
    case 's':
      saveFile();msgState=7; break;
    case 'r': //read file to get parameter
      readFile(); msgState=8; modeRecalc=1; break;
    case 'u':  //rescale the axis
      keyState=9; msgState=9;  modeRecalc=1; break;
    case 'c': //only this key can set modePlot=2 to combine db + deg plot
      keyState=10;   msgState=10;  previousPlot=modePlot; previousLine=modeLine; 
      modePlot=2; modeLine=4;break;
    default:
      resetVar();
    }
  }
  else if (keyState==5) {//'a' for adding PZ
    msgState=5; 
    modeRecalc=1;
    if (keyStateSub==0) {
      switch(key) { //2nd level key for 'a' add PZ
      case '0': 
      case '1':    
      case '2':    
        PZ_t=int(key)-48; 
        msgState=51; 
        keyStateStack=keyState; //stack
        keyState=20;  keyStateSub=1;  //move on to get gain of PZ
        break;
      case 'q':
        msgState=0;        keyState=0;break;//go back to 1st level cmd
      default:
        msgState=5; keyState=5; keyStateSub=0;
      }
    }
    else if (keyStateSub==1) {
      if (keyCode==ENTER) {//get the data for PZ_g
        PZ_g=float(entrySaved);msgState=52;keyStateStack=keyState; keyState=20;keyStateSub=2;  //move on to get f of PZ
      }
      else { resetVar();}
    }
    else if (keyStateSub==2) { //get the data for PZ_f1
      if (keyCode==ENTER) {
        PZ_f1=float(entrySaved);
        if (PZ_t==2) {
          msgState=53;keyStateStack=keyState;keyState=20; keyStateSub=3;  //move on to get f2 of PZ
        }
        else { PZadd();}
      }
      else {      resetVar();}
    }
    else if (keyStateSub==3) { //get the data for PZ_f2
      if (keyCode==ENTER) {PZ_f2=float(entrySaved); PZadd();}
      else {    resetVar();   }
    }
    else { }
  }
  else if (keyState==6) {//remove PZ
    modeRecalc=1;
    if ((int(key)-48)>=0 && (int(key)-48)<plist.size()) {
      plist.remove((int(key)-48));resetVar();
    }
    else if (key=='q') {resetVar();}
    else {msgState=302; keyState=0;}
  }
  else if (keyState==9) {//ajust axis
    int tk;
    tk=int(key)-48;
    if (keyStateSub==0) {
      keyStateSub=1;
      if (tk>=0 && tk<=7) {previousKey=tk;        msgState=91;      }
      else { resetVar();   }
    }
    else if (keyStateSub==1) {
      if (keyCode==UP || keyCode==DOWN) {
        float tUP;
        switch(previousKey) { //Set up value of inc or dec
        case 0:         case 1:           tUP=1;    break;
        case 2:         case 3:           tUP=dbStep;  break;
        case 4:           tUP=1;    break;
        case 5:         case 6:           tUP=degStep;  break;
        case 7:           tUP=1;  break;        
        default:           tUP=0;
        }
        if (keyCode==UP) {}
        else { tUP=-tUP; }//decrese, negate it
        switch(previousKey) { //Perfm op on the axis
        case 0: 
          if (tUP==1) {
            if (NoLineFreq>=3) {              freqMin=freqMin*10;            }
          }
          else {
            if (NoLineFreq<=8) {              freqMin=freqMin/10;            }
          }
          break;
        case 1: 
          if (tUP==1) {
            if (NoLineFreq<=8) {              freqMax=freqMax*10;            }
          } 
          else {
            if (NoLineFreq>=3) {              freqMax=freqMax/10;            }
          }
          break;
        case 2: 
          if (tUP==dbStep) {
            if (NoLineDB>=3 && dbMin < (dbMax-dbStep)) {              dbMin=dbMin+tUP;            }
          }
          else {
            if (NoLineDB<=40 ) {              dbMin=dbMin+tUP;            }
          }
          break;
        case 3: 
          if (tUP==dbStep) {
            if (NoLineDB<=40 ) {              dbMax=dbMax+tUP;            }
          }
          else {
            if (NoLineDB>=3 && dbMax>(dbMin+dbStep)) {              dbMax=dbMax+tUP;            }
          }
          break;
        case 4: 
          if (tUP==1) {
            if (dbStep<=40 ) {              dbStep=dbStep+5;            }
          }
          else {
            if (dbStep>=10) {              dbStep=dbStep-5;            }
          }
          break;
        case 5: 
          if (tUP==degStep) {
            if (NoLineDEG>=3 && degMin < (degMax-degStep)) {              degMin=degMin+tUP;            }
          }
          else {
            if (NoLineDEG<=40 ) {              degMin=degMin+tUP;            }
          }
          break;
        case 6: 
          if (tUP==degStep) {
            if (NoLineDEG<=40 ) {              degMax=degMax+tUP;            }
          }
          else {
            if (NoLineDEG>=3 && degMax>(degMin+90)) {              degMax=degMax+tUP;            }
          }
          break;
        case 7: 
          if (tUP==1) {
            if (degStep<89 ) {              degStep=degStep+11.25;            }
          }
          else {
            if (degStep>=22) {              degStep=degStep-11.25;            }
          }
          break;
        default:
        }
        sB.genFreqArray();
        modeRecalc=1;
      }
      else {        resetVar();      }
    }
    else {    }
  }
  else if (keyState==10) {//to clear the combiation of db/deg plot, all key ignore, only c to restore back
    if (key=='c') {
      modePlot=previousPlot; modeLine=previousLine; //pop the stack
      resetVar();
    }
  }
  else if (keyState==11) {//in modeDyn, 'm' to update PZ position, 'l' to display result of PM
    if (key=='m') {plist.change(); resetVar();}
    else if (key=='d') {
      modeDyn=2;      keyState=12;      msgState=12;
      previousPlot=modePlot;      previousLine=modeLine;       modePlot=2;       modeLine=4;//push stack
    }
    else {      resetVar();    }
  }
  else if (keyState==12) {//in modeDyn, to display FT&PM, 
    switch(key) {
    case 'p':    
      recordPDF=true;         
      msgState=2 ; 
      break;
    case 'o':
      saveFrame(bodeName+"_"+str(fileNo)+".png"); 
      msgState=3 ;
      fileNo++;
      break;
    case 'l': //only allow actual total resp or asympotic tot resp
      if (modeLine==3) {
        modeLine=4;
      }
      else {
        modeLine=3;
      } 
      break;
    case 't':
      if (Dang==0) {
        Dang=PI/2;
      }
      else if (Dang==PI/2) {
        Dang=-PI/2;
      }
      else {
        Dang=0;
      } 
      ;
      break;
    default:
      resetVar();
      modePlot=previousPlot;
      modeLine=previousLine;
    }
  }


  //Data Entry, result keep in entrySaved. Used by various actions
  else if (keyState==20) { 
    msgState=20;
    if (key == CODED && key!='\n' && key!=TAB) {
    } 
    else if (key == '\n' || keyCode == ENTER ) {
      if (entryTyping.length()>=entryMax) {
        entrySaved=entryTyping.substring(0, entryMax);
      }
      else {
        entrySaved=entryTyping;
      }
      entryTyping = "" ; 
      keyState=keyStateStack;
      msgState=201;
    } 
    else if (keyCode == BACKSPACE) {
      entryTyping="";
    }
    else if (entryTyping.length()<entryMax) { 
      entryTyping = entryTyping + key;
    } //append key
    else {
    }
  }
  else {
  }
}

void mousePressed() {
  float[] temp = new float[2];
  //temp=getPt();   
  if (keyState==11) {modeDyn=0;}//
  if (plist.selected_index!=-1 && (modePlot==0 || modePlot==2)) { //can only do dynamic plot in dg mode or combine mode
    modeDyn=1; msgState=11; keyState=11;
    plist.confirmed_index=plist.selected_index;
    plist.confirmed_f2=plist.selected_f2;
    
    //plist.sel
  } 
  if (modeDyn==2) {//once in dynamic mode, a click will exit. Must pop stack
    modeDyn=0;
    resetVar();  
    modePlot=previousPlot;
    modeLine=previousLine;
  }
}

//return 3 current pt {freq,db,deg}
float[] getPt() {
  float[] temp = new float[3];
  ptTemp1=returnPt(); //ptTemp is global;
  ptFreqDbDeg=draw2freqdeg(ptTemp1[0], ptTemp1[1]);
  temp=ptFreqDbDeg;
  return temp;
}

String formatFreq(float f, int dec_pt) { //provide scientfic format, m, K, M, G ...
  String s="";
  if      (f<1) {
    f=f*1000;
    s=nfc(f, dec_pt)+'m';
  }
  else if (f>=1 && f<1000) {
    f=f;
    s=nfc(f, dec_pt);
  }
  else if (f>=1000 && f<1e6) {
    f=f/1000;
    s=nfc(f, dec_pt)+'K';
  }
  else if (f>=1e6  && f<1e9) {
    f=f/1e6;
    s=nfc(f, dec_pt)+'M';
  }
  else {
    f=f/1e9;
    s=nfc(f, dec_pt)+'G';
  }
  return s;
}

float log10 (float x) {
  return (log(x) / log(10));
}

//convert db (db/deg_freq) to drawing board
float[] freq2draw(float freq, float y, int t) {//t=0 for db, 1 for deg 
  float[] temp = new float[2];
  temp[0]=log10(freq/freqMin)*gridFreq;
  if (t==0) {
    temp[1]=gridDB*(dbMax-y)/dbStep;
  }
  else {
    temp[1]=gridDEG*(degMax-y)/degStep;
  }//deg conversion
  return temp;
}

float[][] freq2draw_A(float[] freq, float[] y, int t) {//t=0 for db, 1 for deg, handle array 
  int l=freq.length;
  float[][] temp = new float[2][l];
  for (int i = 0; i < l; i = i+1) {
    temp[0][i]=log10(freq[i]/freqMin)*gridFreq;
    if (t==0) {
      temp[1][i]=gridDB*(dbMax-y[i])/dbStep;
    }
    else {
      temp[1][i]=gridDEG*(degMax-y[i])/degStep;
    }//deg conversion
  }
  return temp;
}

//convert drawing board pt to freq/db pair, return {freq,db,deg}
float[] draw2freqdeg(float x, float y) { 
  float[] temp = new float[3]; //{freq,db,deg}
  temp[0]=freqMin*pow(10, x/gridFreq);
  temp[1]=dbMax-10*y/gridDB;
  temp[2]=degMax-22.5*y/gridDEG; //for deg
  return temp;
}



//return snap pt, constrain to drawing area
float[] returnPt() { 
  float[] temp = new float[2];
  temp[0]=returnGrid(mouseX);
  temp[1]=constrain(returnGrid(mouseY), 0, startLegion);
  return temp;
} 

void drawPlot(float[] f, float[] y, int t, int c, int w, int dotted) { 
  //t=0 for db, 1 for deg
  //dotted=1 for dotted line
  float[][] temp;
  float xStart, yStart, xStop, yStop;
  temp=freq2draw_A(f, y, t); 
  stroke(c);   
  strokeWeight(w);
  for (int i = 0; i < f.length-1; i = i+1) {
    xStart=temp[0][i];   
    yStart=temp[1][i]; 
    xStop =temp[0][i+1]; 
    yStop=temp[1][i+1];
    if (dotted==0) { 
      line(xStart, yStart, xStop, yStop);
    }
    //else          { dottedLine(xStart,yStart, xStop,yStop,5,c);} //freq axis too fine, dot become line already
    else { 
      line(xStart, yStart, xStop, yStop);
    }
  }
} 

//snap to grid
float returnGrid(float x) { 
  float temp;
  //temp=x-(x%resnGrid)+0.025*resnGrid;
  temp=x;
  return temp;
} 

class Complex {
  float real;   // the real part
  float img;   // the imaginary part
  float abs;
  float ang;

  Complex(float real, float img) {
    this.real = real;
    this.img = img;
    this.abs = sqrt(img*img + real*real);
    this.ang = atan(img/real)*180/PI;
    if (this.real<0) {
      this.ang=this.ang+180;
    }
    //if (this.ang>0){this.ang=this.ang-360;} //roll over issues
  }
  Complex conj() {
    float real = this.real;
    float img = -this.img;
    return new Complex(real, img);
  }
  Complex add(Complex b) {
    float real = this.real + b.real;
    float img = this.img   + b.img ;
    return new Complex(real, img);
  }
  Complex multi(Complex b) {
    float real = this.real * b.real - this.img * b.img;
    float img = this.real * b.img + this.img * b.real;
    return new Complex(real, img);
  }
  Complex div(Complex b) {
    float real = this.real * b.real + this.img * b.img;
    float img = -this.real * b.img + this.img * b.real;
    float t = b.real*b.real + b.img*b.img;
    return new Complex(real/t, img/t);
  }
}

Complex returnQP(float Q, float fo, float f) { //do the calc & return a complex no of Q pole
  Complex s1, s2, s3;
  s1=new Complex(0, f/fo);
  s1=s1.multi(s1);
  s2=new Complex(1, f/(Q*fo));
  s3=new Complex(1, 0);
  return s3.div(s2.add(s1));
}

void dottedLine(float x1, float y1, float x2, float y2, float steps, color c) {
  for (int i=0; i<=steps; i++) {
    float x = lerp(x1, x2, i/steps);
    float y = lerp(y1, y2, i/steps);
    noStroke();   
    fill(c);
    ellipse(x, y, 3, 3);
  }
}

void resetVar() {  msgState=0;   keyState=0;   keyStateSub=0;   modeDyn=0; 
}

void PZadd() {
  if (plist.size()>=5) {    msgState=303;    keyState=0;  }
  else if (PZ_g>-1e9 && PZ_g<1e9 && PZ_f1>-1e9 && PZ_f1<1e9 && PZ_f2>-1e9 && PZ_f2<1e9 && PZ_q>=0) {
    p1=new PZ(PZ_t, PZ_g, PZ_q, PZ_f1, PZ_f2);  
    plist.add(p1);
    plist.calcCurve(sB.freqArray); //need to initialize the curves
    resetVar();
  }
  else {    msgState=301;  }
}


void saveFile() {
  bodeFile = createWriter(bodeFileName);
  bodeFile.println(plist.size());
  bodeFile.println(plist.sInfo);
  bodeFile.println(sB.sInfo); 
  bodeFile.flush(); // Writes the remaining data to the file
  bodeFile.close();
}

void readFile() {
  String[] sa;
  String s, f2;
  int no;
  bodeLine = loadStrings(bodeFileName);
  no=int(bodeLine[0]);
  //println("no of pz",no);
  plist.flush();
  for (int i = 1; i <= no; i++ ) {//read PZ first
    s=bodeLine[i];
    s=s.replaceAll("Hz", "").replaceAll("dB", "");
    sa=splitTokens(s, ",:");
    //println(sa);
    //max no of pz is 5
    if (plist.size()<6) { 
          if (int(sa[3])==2 || int(sa[3])==3) {        f2=sa[12];      } 
          else {        f2="0";      }
      p1=new PZ(int(sa[3]), float(sa[6]), float(sa[8]), float(sa[10]), float(f2));  
      plist.add(p1); 
      println(i,"added",int(sa[3]),float(sa[6]),float(sa[8]),float(sa[10]),f2);
    }
    else {
      msgState=303;
    }
  }
  //read all the scale info
  sa=splitTokens(bodeLine[no+2], ",:");
  freqMin=float(sa[1]);
  freqMax=float(sa[3]);//freqStep=float(sa[5]);
  sa=splitTokens(bodeLine[no+3], ",:");
  dbMin=float(sa[1]);
  dbMax=float(sa[3]);
  dbStep=float(sa[5]);
  sa=splitTokens(bodeLine[no+4], ",:");
  degMin=float(sa[1]);
  degMax=float(sa[3]);
  degStep=float(sa[5]);
}

